Hex Artifact Content

Artifact 541777ce91ec4d8d4c82a710c4dadb2cf28e5bfc:


0000: 23 21 20 2f 62 69 6e 2f 62 61 73 68 0a 0a 56 45  #! /bin/bash..VE
0010: 52 53 49 4f 4e 53 3d 22 38 2e 34 2e 31 39 20 38  RSIONS="8.4.19 8
0020: 2e 35 2e 39 20 63 76 73 5f 48 45 41 44 22 0a 0a  .5.9 cvs_HEAD"..
0030: 23 20 46 69 6e 64 20 74 68 65 20 62 61 73 65 20  # Find the base 
0040: 64 69 72 65 63 74 6f 72 79 0a 66 6f 72 20 78 20  directory.for x 
0050: 69 6e 20 31 20 32 20 33 20 5f 5f 66 61 69 6c 5f  in 1 2 3 __fail_
0060: 5f 3b 20 64 6f 0a 09 69 66 20 5b 20 22 24 7b 78  _; do..if [ "${x
0070: 7d 22 20 3d 20 22 24 7b 66 61 69 6c 7d 22 20 5d  }" = "${fail}" ]
0080: 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f 20 27 55  ; then...echo 'U
0090: 6e 61 62 6c 65 20 74 6f 20 66 69 6e 64 20 4b 69  nable to find Ki
00a0: 74 43 72 65 61 74 6f 72 2c 20 61 62 6f 72 74 69  tCreator, aborti
00b0: 6e 67 2e 27 20 3e 26 32 0a 0a 09 09 65 78 69 74  ng.' >&2....exit
00c0: 20 31 0a 09 66 69 0a 0a 09 69 66 20 5b 20 2d 78   1..fi...if [ -x
00d0: 20 6b 69 74 63 72 65 61 74 6f 72 20 5d 3b 20 74   kitcreator ]; t
00e0: 68 65 6e 0a 09 09 62 72 65 61 6b 0a 09 66 69 0a  hen...break..fi.
00f0: 0a 09 63 64 20 2e 2e 0a 64 6f 6e 65 0a 0a 52 4f  ..cd ...done..RO
0100: 4f 54 44 49 52 3d 22 24 28 70 77 64 29 22 0a 54  OTDIR="$(pwd)".T
0110: 45 53 54 44 49 52 3d 22 24 7b 52 4f 4f 54 44 49  ESTDIR="${ROOTDI
0120: 52 7d 2f 62 75 69 6c 64 2f 74 65 73 74 22 0a 65  R}/build/test".e
0130: 78 70 6f 72 74 20 52 4f 4f 54 44 49 52 20 54 45  xport ROOTDIR TE
0140: 53 54 44 49 52 0a 0a 23 20 48 61 6e 64 6c 65 20  STDIR..# Handle 
0150: 63 6f 6d 6d 61 6e 64 2d 6c 69 6e 65 20 61 72 67  command-line arg
0160: 75 6d 65 6e 74 73 0a 69 66 20 5b 20 22 24 31 22  uments.if [ "$1"
0170: 20 3d 20 22 63 6c 65 61 6e 22 20 5d 3b 20 74 68   = "clean" ]; th
0180: 65 6e 0a 09 72 6d 20 2d 72 66 20 22 24 7b 54 45  en..rm -rf "${TE
0190: 53 54 44 49 52 7d 2f 6b 69 74 73 22 0a 66 69 0a  STDIR}/kits".fi.
01a0: 0a 23 20 43 72 65 61 74 65 20 70 6c 61 63 65 20  .# Create place 
01b0: 74 6f 20 70 75 74 20 6b 69 74 73 0a 6d 6b 64 69  to put kits.mkdi
01c0: 72 20 22 24 7b 54 45 53 54 44 49 52 7d 2f 6b 69  r "${TESTDIR}/ki
01d0: 74 73 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32  ts" >/dev/null 2
01e0: 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 6d 6b 64 69 72  >/dev/null.mkdir
01f0: 20 22 24 7b 54 45 53 54 44 49 52 7d 2f 6b 69 74   "${TESTDIR}/kit
0200: 73 2f 66 61 69 6c 65 64 22 20 3e 2f 64 65 76 2f  s/failed" >/dev/
0210: 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c  null 2>/dev/null
0220: 0a 69 66 20 5b 20 21 20 2d 64 20 22 24 7b 54 45  .if [ ! -d "${TE
0230: 53 54 44 49 52 7d 2f 6b 69 74 73 22 20 5d 3b 20  STDIR}/kits" ]; 
0240: 74 68 65 6e 0a 09 65 63 68 6f 20 27 55 6e 61 62  then..echo 'Unab
0250: 6c 65 20 74 6f 20 63 72 65 61 74 65 20 6b 69 74  le to create kit
0260: 73 2f 20 64 69 72 65 63 74 6f 72 79 2c 20 61 62  s/ directory, ab
0270: 6f 72 74 69 6e 67 2e 27 20 3e 26 32 0a 0a 09 65  orting.' >&2...e
0280: 78 69 74 20 31 0a 66 69 0a 0a 23 20 43 6c 65 61  xit 1.fi..# Clea
0290: 6e 75 70 0a 66 6f 72 20 66 69 6c 65 20 69 6e 20  nup.for file in 
02a0: 22 24 7b 54 45 53 54 44 49 52 7d 22 2f 6b 69 74  "${TESTDIR}"/kit
02b0: 73 2f 2a 2e 6c 6f 67 3b 20 64 6f 0a 09 69 66 20  s/*.log; do..if 
02c0: 65 63 68 6f 20 22 24 7b 66 69 6c 65 7d 22 20 7c  echo "${file}" |
02d0: 20 67 72 65 70 20 2d 2d 20 27 2d 62 75 69 6c 64   grep -- '-build
02e0: 2e 6c 6f 67 24 27 20 3e 2f 64 65 76 2f 6e 75 6c  .log$' >/dev/nul
02f0: 6c 3b 20 74 68 65 6e 0a 09 09 63 6f 6e 74 69 6e  l; then...contin
0300: 75 65 0a 09 66 69 0a 0a 09 72 6d 20 2d 66 20 22  ue..fi...rm -f "
0310: 24 7b 66 69 6c 65 7d 22 0a 64 6f 6e 65 0a 0a 66  ${file}".done..f
0320: 61 69 6c 65 64 3d 22 22 0a 66 6f 72 20 6b 69 74  ailed="".for kit
0330: 20 69 6e 20 6e 6f 72 6d 61 6c 20 6e 6f 72 6d 61   in normal norma
0340: 6c 2d 7a 69 70 20 6e 6f 72 6d 61 6c 2d 74 68 72  l-zip normal-thr
0350: 65 61 64 65 64 20 6e 6f 72 6d 61 6c 2d 74 68 72  eaded normal-thr
0360: 65 61 64 65 64 2d 7a 69 70 20 6e 6f 72 6d 61 6c  eaded-zip normal
0370: 2d 73 74 61 74 69 63 74 6b 20 6e 6f 72 6d 61 6c  -statictk normal
0380: 2d 6e 6f 74 6b 20 6e 6f 72 6d 61 6c 2d 74 68 72  -notk normal-thr
0390: 65 61 64 65 64 2d 6e 6f 74 6b 20 6e 6f 72 6d 61  eaded-notk norma
03a0: 6c 2d 74 68 72 65 61 64 65 64 2d 7a 69 70 2d 6e  l-threaded-zip-n
03b0: 6f 74 6b 20 6d 69 6e 20 6d 69 6e 2d 73 74 61 74  otk min min-stat
03c0: 69 63 20 77 69 6e 33 32 20 77 69 6e 33 32 2d 7a  ic win32 win32-z
03d0: 69 70 20 77 69 6e 33 32 2d 74 68 72 65 61 64 65  ip win32-threade
03e0: 64 20 77 69 6e 33 32 2d 74 68 72 65 61 64 65 64  d win32-threaded
03f0: 2d 7a 69 70 20 77 69 6e 33 32 2d 6e 6f 74 6b 20  -zip win32-notk 
0400: 77 69 6e 33 32 2d 74 68 72 65 61 64 65 64 2d 6e  win32-threaded-n
0410: 6f 74 6b 20 61 72 6d 2d 6d 69 6e 3b 20 64 6f 0a  otk arm-min; do.
0420: 09 6b 69 74 63 72 65 61 74 6f 72 3d 22 2e 2f 6b  .kitcreator="./k
0430: 69 74 63 72 65 61 74 6f 72 22 0a 09 61 72 67 73  itcreator"..args
0440: 3d 22 22 0a 09 72 75 6e 6e 61 62 6c 65 3d 22 31  =""..runnable="1
0450: 22 0a 09 69 73 7a 69 70 3d 22 30 22 0a 09 73 74  "..iszip="0"..st
0460: 61 74 69 63 74 6b 3d 22 30 22 0a 09 6e 6f 74 6b  atictk="0"..notk
0470: 3d 22 30 22 0a 0a 09 23 20 48 61 6e 64 6c 65 20  ="0"...# Handle 
0480: 62 61 73 65 20 63 6f 6e 66 69 67 75 72 61 74 69  base configurati
0490: 6f 6e 0a 09 63 61 73 65 20 22 24 7b 6b 69 74 7d  on..case "${kit}
04a0: 22 20 69 6e 0a 09 09 6e 6f 72 6d 61 6c 7c 6e 6f  " in...normal|no
04b0: 72 6d 61 6c 2d 2a 29 0a 09 09 09 74 72 75 65 0a  rmal-*)....true.
04c0: 09 09 09 3b 3b 0a 09 09 6d 69 6e 29 0a 09 09 09  ...;;...min)....
04d0: 6b 69 74 63 72 65 61 74 6f 72 3d 22 2e 2f 62 75  kitcreator="./bu
04e0: 69 6c 64 2f 6d 61 6b 65 2d 6d 69 6e 6b 69 74 22  ild/make-minkit"
04f0: 0a 09 09 09 69 73 7a 69 70 3d 22 31 22 0a 09 09  ....iszip="1"...
0500: 09 6e 6f 74 6b 3d 22 31 22 0a 09 09 09 3b 3b 0a  .notk="1"....;;.
0510: 09 09 6d 69 6e 2d 73 74 61 74 69 63 29 0a 09 09  ..min-static)...
0520: 09 6b 69 74 63 72 65 61 74 6f 72 3d 22 2e 2f 62  .kitcreator="./b
0530: 75 69 6c 64 2f 6d 61 6b 65 2d 6d 69 6e 6b 69 74  uild/make-minkit
0540: 2d 73 74 61 74 69 63 22 0a 09 09 09 69 73 7a 69  -static"....iszi
0550: 70 3d 22 31 22 0a 09 09 09 6e 6f 74 6b 3d 22 31  p="1"....notk="1
0560: 22 0a 09 09 09 3b 3b 0a 09 09 77 69 6e 33 32 7c  "....;;...win32|
0570: 77 69 6e 33 32 2d 2a 29 0a 09 09 09 6b 69 74 63  win32-*)....kitc
0580: 72 65 61 74 6f 72 3d 22 2e 2f 62 75 69 6c 64 2f  reator="./build/
0590: 6d 61 6b 65 2d 6b 69 74 2d 77 69 6e 33 32 22 0a  make-kit-win32".
05a0: 09 09 09 72 75 6e 6e 61 62 6c 65 3d 22 30 22 0a  ...runnable="0".
05b0: 09 09 09 3b 3b 0a 09 09 61 72 6d 2d 6d 69 6e 29  ...;;...arm-min)
05c0: 0a 09 09 09 6b 69 74 63 72 65 61 74 6f 72 3d 22  ....kitcreator="
05d0: 2e 2f 62 75 69 6c 64 2f 6d 61 6b 65 2d 6b 69 74  ./build/make-kit
05e0: 2d 61 72 6d 22 0a 09 09 09 72 75 6e 6e 61 62 6c  -arm"....runnabl
05f0: 65 3d 22 30 22 0a 09 09 09 6e 6f 74 6b 3d 22 31  e="0"....notk="1
0600: 22 0a 09 09 09 69 73 7a 69 70 3d 22 31 22 0a 09  "....iszip="1"..
0610: 09 09 3b 3b 0a 09 65 73 61 63 0a 0a 09 23 20 48  ..;;..esac...# H
0620: 61 6e 64 6c 65 20 61 64 64 69 74 69 6f 6e 61 6c  andle additional
0630: 20 63 6f 6e 66 69 67 75 72 61 74 69 6f 6e 0a 09   configuration..
0640: 74 65 6d 70 6b 69 74 3d 22 2d 24 7b 6b 69 74 7d  tempkit="-${kit}
0650: 2d 22 0a 09 66 6f 72 20 74 72 79 20 69 6e 20 31  -"..for try in 1
0660: 20 32 20 33 20 34 20 35 20 36 20 37 20 38 20 39   2 3 4 5 6 7 8 9
0670: 3b 20 64 6f 0a 09 09 63 61 73 65 20 22 2d 24 7b  ; do...case "-${
0680: 74 65 6d 70 6b 69 74 7d 2d 22 20 69 6e 0a 09 09  tempkit}-" in...
0690: 09 2a 2d 74 68 72 65 61 64 65 64 2d 2a 29 0a 09  .*-threaded-*)..
06a0: 09 09 09 74 65 6d 70 6b 69 74 3d 22 24 28 65 63  ...tempkit="$(ec
06b0: 68 6f 20 22 24 7b 74 65 6d 70 6b 69 74 7d 22 20  ho "${tempkit}" 
06c0: 7c 20 73 65 64 20 27 73 40 2d 74 68 72 65 61 64  | sed 's@-thread
06d0: 65 64 2d 40 2d 40 27 29 22 0a 09 09 09 09 61 72  ed-@-@')".....ar
06e0: 67 73 3d 22 24 7b 61 72 67 73 7d 20 2d 2d 65 6e  gs="${args} --en
06f0: 61 62 6c 65 2d 74 68 72 65 61 64 73 22 0a 09 09  able-threads"...
0700: 09 09 3b 3b 0a 09 09 09 2a 2d 7a 69 70 2d 2a 29  ..;;....*-zip-*)
0710: 0a 09 09 09 09 74 65 6d 70 6b 69 74 3d 22 24 28  .....tempkit="$(
0720: 65 63 68 6f 20 22 24 7b 74 65 6d 70 6b 69 74 7d  echo "${tempkit}
0730: 22 20 7c 20 73 65 64 20 27 73 40 2d 7a 69 70 2d  " | sed 's@-zip-
0740: 40 2d 40 27 29 22 0a 09 09 09 09 61 72 67 73 3d  @-@')".....args=
0750: 22 24 7b 61 72 67 73 7d 20 2d 2d 65 6e 61 62 6c  "${args} --enabl
0760: 65 2d 6b 69 74 2d 73 74 6f 72 61 67 65 3d 7a 69  e-kit-storage=zi
0770: 70 22 0a 09 09 09 09 69 73 7a 69 70 3d 22 31 22  p".....iszip="1"
0780: 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 2d 73 74 61  .....;;....*-sta
0790: 74 69 63 74 6b 2d 2a 29 0a 09 09 09 09 74 65 6d  tictk-*).....tem
07a0: 70 6b 69 74 3d 22 24 28 65 63 68 6f 20 22 24 7b  pkit="$(echo "${
07b0: 74 65 6d 70 6b 69 74 7d 22 20 7c 20 73 65 64 20  tempkit}" | sed 
07c0: 27 73 40 2d 73 74 61 74 69 63 74 6b 2d 40 2d 40  's@-statictk-@-@
07d0: 27 29 22 0a 09 09 09 09 69 66 20 5b 20 22 24 7b  ')".....if [ "${
07e0: 6e 6f 74 6b 7d 22 20 3d 20 22 30 22 20 5d 3b 20  notk}" = "0" ]; 
07f0: 74 68 65 6e 0a 09 09 09 09 09 73 74 61 74 69 63  then......static
0800: 74 6b 3d 22 31 22 0a 09 09 09 09 65 6c 73 65 0a  tk="1".....else.
0810: 09 09 09 09 09 65 63 68 6f 20 22 24 7b 6b 69 74  .....echo "${kit
0820: 7d 3a 20 55 6e 61 62 6c 65 20 74 6f 20 63 72 65  }: Unable to cre
0830: 61 74 65 20 53 74 61 74 69 63 54 6b 20 61 6e 64  ate StaticTk and
0840: 20 4e 6f 54 6b 2c 20 69 67 6e 6f 72 69 6e 67 20   NoTk, ignoring 
0850: 53 74 61 74 69 63 54 6b 22 20 3e 26 32 0a 09 09  StaticTk" >&2...
0860: 09 09 66 69 0a 09 09 09 09 3b 3b 0a 09 09 09 2a  ..fi.....;;....*
0870: 2d 6e 6f 74 6b 2d 2a 29 0a 09 09 09 09 74 65 6d  -notk-*).....tem
0880: 70 6b 69 74 3d 22 24 28 65 63 68 6f 20 22 24 7b  pkit="$(echo "${
0890: 74 65 6d 70 6b 69 74 7d 22 20 7c 20 73 65 64 20  tempkit}" | sed 
08a0: 27 73 40 2d 6e 6f 74 6b 2d 40 2d 40 27 29 22 0a  's@-notk-@-@')".
08b0: 09 09 09 09 69 66 20 5b 20 22 24 7b 73 74 61 74  ....if [ "${stat
08c0: 69 63 74 6b 7d 22 20 3d 20 22 30 22 20 5d 3b 20  ictk}" = "0" ]; 
08d0: 74 68 65 6e 0a 09 09 09 09 09 6e 6f 74 6b 3d 22  then......notk="
08e0: 31 22 0a 09 09 09 09 65 6c 73 65 0a 09 09 09 09  1".....else.....
08f0: 09 65 63 68 6f 20 22 24 7b 6b 69 74 7d 3a 20 55  .echo "${kit}: U
0900: 6e 61 62 6c 65 20 74 6f 20 63 72 65 61 74 65 20  nable to create 
0910: 53 74 61 74 69 63 54 6b 20 61 6e 64 20 4e 6f 54  StaticTk and NoT
0920: 6b 2c 20 69 67 6e 6f 72 69 6e 67 20 4e 6f 54 6b  k, ignoring NoTk
0930: 22 20 3e 26 32 0a 09 09 09 09 66 69 0a 09 09 09  " >&2.....fi....
0940: 09 3b 3b 0a 09 09 65 73 61 63 0a 09 64 6f 6e 65  .;;...esac..done
0950: 0a 0a 09 66 6f 72 20 76 65 72 73 69 6f 6e 20 69  ...for version i
0960: 6e 20 24 7b 56 45 52 53 49 4f 4e 53 7d 3b 20 64  n ${VERSIONS}; d
0970: 6f 0a 09 09 23 20 43 72 65 61 74 65 20 54 63 6c  o...# Create Tcl
0980: 6b 69 74 0a 09 09 63 72 65 61 74 65 64 6b 69 74  kit...createdkit
0990: 3d 22 74 63 6c 6b 69 74 2d 24 7b 76 65 72 73 69  ="tclkit-${versi
09a0: 6f 6e 7d 22 0a 09 09 6f 75 74 70 75 74 6e 61 6d  on}"...outputnam
09b0: 65 3d 22 24 7b 54 45 53 54 44 49 52 7d 2f 6b 69  e="${TESTDIR}/ki
09c0: 74 73 2f 74 63 6c 6b 69 74 2d 24 7b 76 65 72 73  ts/tclkit-${vers
09d0: 69 6f 6e 7d 2d 24 7b 6b 69 74 7d 22 0a 09 09 66  ion}-${kit}"...f
09e0: 61 69 6c 6f 75 74 70 75 74 6e 61 6d 65 3d 22 24  ailoutputname="$
09f0: 7b 54 45 53 54 44 49 52 7d 2f 6b 69 74 73 2f 66  {TESTDIR}/kits/f
0a00: 61 69 6c 65 64 2f 74 63 6c 6b 69 74 2d 24 7b 76  ailed/tclkit-${v
0a10: 65 72 73 69 6f 6e 7d 2d 24 7b 6b 69 74 7d 22 0a  ersion}-${kit}".
0a20: 09 09 62 75 69 6c 64 6c 6f 67 3d 22 24 7b 6f 75  ..buildlog="${ou
0a30: 74 70 75 74 6e 61 6d 65 7d 2d 62 75 69 6c 64 2e  tputname}-build.
0a40: 6c 6f 67 22 0a 09 09 66 61 69 6c 62 75 69 6c 64  log"...failbuild
0a50: 6c 6f 67 3d 22 24 7b 66 61 69 6c 6f 75 74 70 75  log="${failoutpu
0a60: 74 6e 61 6d 65 7d 2d 62 75 69 6c 64 2e 6c 6f 67  tname}-build.log
0a70: 22 0a 0a 09 09 69 66 20 5b 20 21 20 2d 66 20 22  "....if [ ! -f "
0a80: 24 7b 6f 75 74 70 75 74 6e 61 6d 65 7d 22 20 5d  ${outputname}" ]
0a90: 3b 20 74 68 65 6e 0a 09 09 09 75 6e 73 65 74 20  ; then....unset 
0aa0: 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47 53 20  KITCREATOR_PKGS 
0ab0: 53 54 41 54 49 43 54 4b 0a 0a 09 09 09 69 66 20  STATICTK.....if 
0ac0: 5b 20 2d 66 20 22 24 7b 66 61 69 6c 6f 75 74 70  [ -f "${failoutp
0ad0: 75 74 6e 61 6d 65 7d 22 20 5d 3b 20 74 68 65 6e  utname}" ]; then
0ae0: 0a 09 09 09 09 65 63 68 6f 20 22 53 6b 69 70 70  .....echo "Skipp
0af0: 69 6e 67 20 72 65 62 75 69 6c 64 69 6e 67 20 66  ing rebuilding f
0b00: 61 69 6c 65 64 20 6b 69 74 20 24 7b 76 65 72 73  ailed kit ${vers
0b10: 69 6f 6e 7d 2f 24 7b 6b 69 74 7d 20 2e 2e 2e 22  ion}/${kit} ..."
0b20: 0a 0a 09 09 09 09 66 61 69 6c 65 64 3d 22 24 7b  ......failed="${
0b30: 66 61 69 6c 65 64 7d 20 24 7b 76 65 72 73 69 6f  failed} ${versio
0b40: 6e 7d 2f 24 7b 6b 69 74 7d 2d 62 75 69 6c 64 22  n}/${kit}-build"
0b50: 0a 0a 09 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09  ......continue..
0b60: 09 09 66 69 0a 0a 09 09 09 65 63 68 6f 20 22 43  ..fi.....echo "C
0b70: 72 65 61 74 69 6e 67 20 54 63 6c 6b 69 74 20 24  reating Tclkit $
0b80: 7b 76 65 72 73 69 6f 6e 7d 2f 24 7b 6b 69 74 7d  {version}/${kit}
0b90: 2e 2e 2e 22 0a 0a 09 09 09 69 66 20 5b 20 22 24  ...".....if [ "$
0ba0: 7b 6e 6f 74 6b 7d 22 20 3d 20 22 31 22 20 5d 3b  {notk}" = "1" ];
0bb0: 20 74 68 65 6e 0a 09 09 09 09 4b 49 54 43 52 45   then.....KITCRE
0bc0: 41 54 4f 52 5f 50 4b 47 53 3d 27 69 74 63 6c 20  ATOR_PKGS='itcl 
0bd0: 6d 6b 34 74 63 6c 27 0a 09 09 09 09 65 78 70 6f  mk4tcl'.....expo
0be0: 72 74 20 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b  rt KITCREATOR_PK
0bf0: 47 53 0a 09 09 09 66 69 0a 0a 09 09 09 69 66 20  GS....fi.....if 
0c00: 5b 20 22 24 7b 73 74 61 74 69 63 74 6b 7d 22 20  [ "${statictk}" 
0c10: 3d 20 22 31 22 20 5d 3b 20 74 68 65 6e 0a 09 09  = "1" ]; then...
0c20: 09 09 53 54 41 54 49 43 54 4b 3d 22 31 22 0a 09  ..STATICTK="1"..
0c30: 09 09 09 65 78 70 6f 72 74 20 53 54 41 54 49 43  ...export STATIC
0c40: 54 4b 0a 09 09 09 66 69 0a 0a 09 09 09 62 75 69  TK....fi.....bui
0c50: 6c 64 66 61 69 6c 65 64 3d 22 30 22 0a 09 09 09  ldfailed="0"....
0c60: 22 24 7b 6b 69 74 63 72 65 61 74 6f 72 7d 22 20  "${kitcreator}" 
0c70: 22 24 7b 76 65 72 73 69 6f 6e 7d 22 20 24 7b 61  "${version}" ${a
0c80: 72 67 73 7d 20 3e 20 22 24 7b 62 75 69 6c 64 6c  rgs} > "${buildl
0c90: 6f 67 7d 22 20 32 3e 26 31 20 7c 7c 20 62 75 69  og}" 2>&1 || bui
0ca0: 6c 64 66 61 69 6c 65 64 3d 22 31 22 0a 09 09 09  ldfailed="1"....
0cb0: 67 72 65 70 20 2d 6e 20 27 5e 27 20 2a 2f 62 75  grep -n '^' */bu
0cc0: 69 6c 64 2e 6c 6f 67 20 3e 3e 20 22 24 7b 62 75  ild.log >> "${bu
0cd0: 69 6c 64 6c 6f 67 7d 22 20 32 3e 26 31 0a 0a 09  ildlog}" 2>&1...
0ce0: 09 09 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 63  ..if [ ! -f "${c
0cf0: 72 65 61 74 65 64 6b 69 74 7d 22 20 5d 3b 20 74  reatedkit}" ]; t
0d00: 68 65 6e 0a 09 09 09 09 65 63 68 6f 20 22 46 61  hen.....echo "Fa
0d10: 69 6c 65 64 20 74 6f 20 63 72 65 61 74 65 20 6b  iled to create k
0d20: 69 74 20 24 7b 76 65 72 73 69 6f 6e 7d 2f 24 7b  it ${version}/${
0d30: 6b 69 74 7d 22 20 3e 26 32 0a 0a 09 09 09 09 66  kit}" >&2......f
0d40: 61 69 6c 65 64 3d 22 24 7b 66 61 69 6c 65 64 7d  ailed="${failed}
0d50: 20 24 7b 76 65 72 73 69 6f 6e 7d 2f 24 7b 6b 69   ${version}/${ki
0d60: 74 7d 2d 62 75 69 6c 64 22 0a 0a 09 09 09 09 74  t}-build"......t
0d70: 6f 75 63 68 20 22 24 7b 66 61 69 6c 6f 75 74 70  ouch "${failoutp
0d80: 75 74 6e 61 6d 65 7d 22 0a 09 09 09 09 6d 76 20  utname}".....mv 
0d90: 22 24 7b 62 75 69 6c 64 6c 6f 67 7d 22 20 22 24  "${buildlog}" "$
0da0: 7b 66 61 69 6c 62 75 69 6c 64 6c 6f 67 7d 22 0a  {failbuildlog}".
0db0: 0a 09 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09 09  .....continue...
0dc0: 09 66 69 0a 0a 09 09 09 23 20 56 65 72 69 66 79  .fi.....# Verify
0dd0: 20 73 61 6e 69 74 79 20 6f 66 20 63 72 65 61 74   sanity of creat
0de0: 65 64 20 6b 69 74 0a 09 09 09 69 73 73 61 6e 65  ed kit....issane
0df0: 3d 31 0a 0a 09 09 09 23 23 20 56 65 72 69 66 79  =1.....## Verify
0e00: 20 74 68 65 20 57 69 6e 33 32 20 6b 69 74 73 20   the Win32 kits 
0e10: 61 72 65 20 0a 09 09 09 63 61 73 65 20 22 2d 24  are ....case "-$
0e20: 7b 76 65 72 73 69 6f 6e 7d 2d 24 7b 6b 69 74 7d  {version}-${kit}
0e30: 2d 22 20 69 6e 0a 09 09 09 09 2a 2d 77 69 6e 33  -" in.....*-win3
0e40: 32 2d 6e 6f 74 6b 2d 2a 7c 2a 2d 77 69 6e 33 32  2-notk-*|*-win32
0e50: 2d 2a 2d 6e 6f 74 6b 2d 2a 29 0a 09 09 09 09 09  -*-notk-*)......
0e60: 69 66 20 21 20 66 69 6c 65 20 22 24 7b 63 72 65  if ! file "${cre
0e70: 61 74 65 64 6b 69 74 7d 22 20 7c 20 67 72 65 70  atedkit}" | grep
0e80: 20 27 4d 53 20 57 69 6e 64 6f 77 73 20 28 63 6f   'MS Windows (co
0e90: 6e 73 6f 6c 65 29 27 20 3e 2f 64 65 76 2f 6e 75  nsole)' >/dev/nu
0ea0: 6c 6c 3b 20 74 68 65 6e 0a 09 09 09 09 09 09 65  ll; then.......e
0eb0: 63 68 6f 20 22 4b 69 74 20 66 61 69 6c 65 64 20  cho "Kit failed 
0ec0: 73 61 6e 69 74 79 20 63 68 65 63 6b 20 66 6f 72  sanity check for
0ed0: 20 62 65 69 6e 67 20 61 20 63 6f 6e 73 6f 6c 65   being a console
0ee0: 20 61 70 70 6c 69 63 61 74 69 6f 6e 22 20 3e 26   application" >&
0ef0: 32 0a 09 09 09 09 09 09 69 73 73 61 6e 65 3d 30  2.......issane=0
0f00: 0a 09 09 09 09 09 66 69 0a 09 09 09 09 09 3b 3b  ......fi......;;
0f10: 0a 09 09 09 09 2a 2d 77 69 6e 33 32 2d 2a 29 0a  .....*-win32-*).
0f20: 09 09 09 09 09 69 66 20 21 20 66 69 6c 65 20 22  .....if ! file "
0f30: 24 7b 63 72 65 61 74 65 64 6b 69 74 7d 22 20 7c  ${createdkit}" |
0f40: 20 67 72 65 70 20 27 4d 53 20 57 69 6e 64 6f 77   grep 'MS Window
0f50: 73 20 28 47 55 49 29 27 20 3e 2f 64 65 76 2f 6e  s (GUI)' >/dev/n
0f60: 75 6c 6c 3b 20 74 68 65 6e 0a 09 09 09 09 09 09  ull; then.......
0f70: 65 63 68 6f 20 22 4b 69 74 20 66 61 69 6c 65 64  echo "Kit failed
0f80: 20 73 61 6e 69 74 79 20 63 68 65 63 6b 20 66 6f   sanity check fo
0f90: 72 20 62 65 69 6e 67 20 61 20 47 55 49 20 61 70  r being a GUI ap
0fa0: 70 6c 69 63 61 74 69 6f 6e 22 20 3e 26 32 0a 09  plication" >&2..
0fb0: 09 09 09 09 09 69 73 73 61 6e 65 3d 30 0a 09 09  .....issane=0...
0fc0: 09 09 09 66 69 0a 09 09 09 09 09 3b 3b 0a 09 09  ...fi......;;...
0fd0: 09 65 73 61 63 0a 0a 09 09 09 23 23 20 56 65 72  .esac.....## Ver
0fe0: 69 66 79 20 74 68 65 20 62 75 69 6c 64 20 63 6f  ify the build co
0ff0: 6d 70 6c 65 74 65 64 20 77 69 74 68 6f 75 74 20  mpleted without 
1000: 77 61 72 6e 69 6e 67 73 0a 09 09 09 69 66 20 5b  warnings....if [
1010: 20 22 24 7b 62 75 69 6c 64 66 61 69 6c 65 64 7d   "${buildfailed}
1020: 22 20 3d 20 22 31 22 20 5d 3b 20 74 68 65 6e 0a  " = "1" ]; then.
1030: 09 09 09 09 65 63 68 6f 20 22 4b 69 74 20 66 61  ....echo "Kit fa
1040: 69 6c 65 64 20 73 61 6e 69 74 79 20 63 68 65 63  iled sanity chec
1050: 6b 20 66 6f 72 20 42 75 69 6c 64 69 6e 67 22 20  k for Building" 
1060: 3e 26 32 0a 0a 09 09 09 09 69 73 73 61 6e 65 3d  >&2......issane=
1070: 30 0a 09 09 09 66 69 0a 0a 09 09 09 23 20 4d 61  0....fi.....# Ma
1080: 6b 65 20 6e 6f 74 65 20 6f 66 20 73 61 6e 69 74  ke note of sanit
1090: 79 20 66 61 69 6c 75 72 65 0a 09 09 09 69 66 20  y failure....if 
10a0: 5b 20 22 24 7b 69 73 73 61 6e 65 7d 22 20 21 3d  [ "${issane}" !=
10b0: 20 22 31 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09   "1" ]; then....
10c0: 09 65 63 68 6f 20 22 4b 69 74 20 66 61 69 6c 65  .echo "Kit faile
10d0: 64 20 73 61 6e 69 74 79 20 24 7b 76 65 72 73 69  d sanity ${versi
10e0: 6f 6e 7d 2f 24 7b 6b 69 74 7d 22 20 3e 26 32 0a  on}/${kit}" >&2.
10f0: 0a 09 09 09 09 66 61 69 6c 65 64 3d 22 24 7b 66  .....failed="${f
1100: 61 69 6c 65 64 7d 20 24 7b 76 65 72 73 69 6f 6e  ailed} ${version
1110: 7d 2f 24 7b 6b 69 74 7d 2d 73 61 6e 69 74 79 22  }/${kit}-sanity"
1120: 0a 0a 09 09 09 09 6d 76 20 22 24 7b 63 72 65 61  ......mv "${crea
1130: 74 65 64 6b 69 74 7d 22 20 22 24 7b 66 61 69 6c  tedkit}" "${fail
1140: 6f 75 74 70 75 74 6e 61 6d 65 7d 22 0a 09 09 09  outputname}"....
1150: 09 6d 76 20 22 24 7b 62 75 69 6c 64 6c 6f 67 7d  .mv "${buildlog}
1160: 22 20 22 24 7b 66 61 69 6c 62 75 69 6c 64 6c 6f  " "${failbuildlo
1170: 67 7d 22 0a 0a 09 09 09 09 63 6f 6e 74 69 6e 75  g}"......continu
1180: 65 0a 09 09 09 66 69 0a 0a 09 09 09 23 20 52 65  e....fi.....# Re
1190: 6e 61 6d 65 20 63 72 65 61 74 65 64 20 6b 69 74  name created kit
11a0: 20 74 6f 20 66 69 6e 61 6c 20 64 65 73 74 69 6e   to final destin
11b0: 61 74 69 6f 6e 0a 09 09 09 6d 76 20 22 24 7b 63  ation....mv "${c
11c0: 72 65 61 74 65 64 6b 69 74 7d 22 20 22 24 7b 6f  reatedkit}" "${o
11d0: 75 74 70 75 74 6e 61 6d 65 7d 22 0a 09 09 66 69  utputname}"...fi
11e0: 0a 0a 09 09 23 20 54 65 73 74 20 7a 69 70 20 73  ....# Test zip s
11f0: 74 61 74 75 73 0a 09 09 69 66 20 75 6e 7a 69 70  tatus...if unzip
1200: 20 2d 6c 20 22 24 7b 6f 75 74 70 75 74 6e 61 6d   -l "${outputnam
1210: 65 7d 22 20 32 3e 26 31 20 7c 20 67 72 65 70 20  e}" 2>&1 | grep 
1220: 27 62 6f 6f 74 5c 2e 74 63 6c 27 20 3e 2f 64 65  'boot\.tcl' >/de
1230: 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 09 09  v/null; then....
1240: 63 61 6e 75 6e 7a 69 70 3d 22 31 22 0a 09 09 65  canunzip="1"...e
1250: 6c 73 65 0a 09 09 09 63 61 6e 75 6e 7a 69 70 3d  lse....canunzip=
1260: 22 30 22 0a 09 09 66 69 0a 0a 09 09 69 66 20 5b  "0"...fi....if [
1270: 20 22 24 7b 69 73 7a 69 70 7d 22 20 21 3d 20 22   "${iszip}" != "
1280: 24 7b 63 61 6e 75 6e 7a 69 70 7d 22 20 5d 3b 20  ${canunzip}" ]; 
1290: 74 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 46 61  then....echo "Fa
12a0: 69 6c 65 64 20 74 6f 20 75 6e 7a 69 70 20 7a 69  iled to unzip zi
12b0: 70 6b 69 74 20 6f 72 20 77 61 73 20 61 62 6c 65  pkit or was able
12c0: 20 74 6f 20 75 6e 7a 69 70 20 6e 6f 6e 2d 7a 69   to unzip non-zi
12d0: 70 6b 69 74 20 24 7b 76 65 72 73 69 6f 6e 7d 2f  pkit ${version}/
12e0: 24 7b 6b 69 74 7d 22 20 3e 26 32 0a 0a 09 09 09  ${kit}" >&2.....
12f0: 66 61 69 6c 65 64 3d 22 24 7b 66 61 69 6c 65 64  failed="${failed
1300: 7d 20 24 7b 76 65 72 73 69 6f 6e 7d 2f 24 7b 6b  } ${version}/${k
1310: 69 74 7d 2d 7a 69 70 22 0a 0a 09 09 09 63 6f 6e  it}-zip".....con
1320: 74 69 6e 75 65 0a 09 09 66 69 0a 0a 09 09 23 20  tinue...fi....# 
1330: 44 6f 20 6e 6f 74 20 63 6f 6e 74 69 6e 75 65 20  Do not continue 
1340: 70 61 73 74 20 68 65 72 65 20 66 6f 72 20 75 6e  past here for un
1350: 2d 72 75 6e 6e 61 62 6c 65 20 6b 69 74 73 0a 09  -runnable kits..
1360: 09 69 66 20 5b 20 22 24 7b 72 75 6e 6e 61 62 6c  .if [ "${runnabl
1370: 65 7d 22 20 21 3d 20 22 31 22 20 5d 3b 20 74 68  e}" != "1" ]; th
1380: 65 6e 0a 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09  en....continue..
1390: 09 66 69 0a 0a 09 09 23 20 50 65 72 66 6f 72 6d  .fi....# Perform
13a0: 20 62 61 74 74 65 72 79 20 6f 66 20 74 65 73 74   battery of test
13b0: 73 0a 09 09 66 6f 72 20 74 65 73 74 73 63 70 20  s...for testscp 
13c0: 69 6e 20 22 24 7b 54 45 53 54 44 49 52 7d 22 2f  in "${TESTDIR}"/
13d0: 74 65 73 74 73 2f 2a 2e 74 63 6c 3b 20 64 6f 0a  tests/*.tcl; do.
13e0: 09 09 09 74 65 73 74 73 63 70 5f 74 61 67 3d 22  ...testscp_tag="
13f0: 24 28 62 61 73 65 6e 61 6d 65 20 22 24 7b 74 65  $(basename "${te
1400: 73 74 73 63 70 7d 22 20 2e 74 63 6c 29 22 0a 09  stscp}" .tcl)"..
1410: 09 09 74 65 73 74 73 63 70 70 72 65 3d 22 24 28  ..testscppre="$(
1420: 64 69 72 6e 61 6d 65 20 22 24 7b 74 65 73 74 73  dirname "${tests
1430: 63 70 7d 22 29 2f 24 7b 74 65 73 74 73 63 70 5f  cp}")/${testscp_
1440: 74 61 67 7d 2e 73 68 22 0a 09 09 09 73 63 70 6c  tag}.sh"....scpl
1450: 6f 67 66 69 6c 65 3d 22 24 7b 6f 75 74 70 75 74  ogfile="${output
1460: 6e 61 6d 65 7d 2d 24 7b 74 65 73 74 73 63 70 5f  name}-${testscp_
1470: 74 61 67 7d 2e 6c 6f 67 22 0a 0a 09 09 09 28 0a  tag}.log".....(.
1480: 09 09 09 09 69 66 20 5b 20 2d 66 20 22 24 7b 74  ....if [ -f "${t
1490: 65 73 74 73 63 70 70 72 65 7d 22 20 5d 3b 20 74  estscppre}" ]; t
14a0: 68 65 6e 0a 09 09 09 09 09 2e 20 22 24 7b 74 65  hen....... "${te
14b0: 73 74 73 63 70 70 72 65 7d 22 0a 09 09 09 09 66  stscppre}".....f
14c0: 69 0a 0a 09 09 09 09 22 24 7b 6f 75 74 70 75 74  i......"${output
14d0: 6e 61 6d 65 7d 22 20 22 24 7b 74 65 73 74 73 63  name}" "${testsc
14e0: 70 7d 22 20 22 24 7b 6f 75 74 70 75 74 6e 61 6d  p}" "${outputnam
14f0: 65 7d 22 20 22 24 7b 6b 69 74 7d 22 20 22 24 7b  e}" "${kit}" "${
1500: 76 65 72 73 69 6f 6e 7d 22 0a 09 09 09 29 20 3e  version}"....) >
1510: 20 22 24 7b 73 63 70 6c 6f 67 66 69 6c 65 7d 22   "${scplogfile}"
1520: 20 32 3e 26 31 0a 0a 09 09 09 69 66 20 5b 20 22   2>&1.....if [ "
1530: 24 3f 22 20 21 3d 20 22 30 22 20 5d 3b 20 74 68  $?" != "0" ]; th
1540: 65 6e 0a 09 09 09 09 65 63 68 6f 20 22 53 63 72  en.....echo "Scr
1550: 69 70 74 20 66 61 69 6c 65 64 3a 20 24 7b 74 65  ipt failed: ${te
1560: 73 74 73 63 70 5f 74 61 67 7d 20 6f 6e 20 24 7b  stscp_tag} on ${
1570: 76 65 72 73 69 6f 6e 7d 2f 24 7b 6b 69 74 7d 22  version}/${kit}"
1580: 20 3e 26 32 0a 0a 09 09 09 09 66 61 69 6c 65 64   >&2......failed
1590: 3d 22 24 7b 66 61 69 6c 65 64 7d 20 24 7b 76 65  ="${failed} ${ve
15a0: 72 73 69 6f 6e 7d 2f 24 7b 6b 69 74 7d 2d 74 65  rsion}/${kit}-te
15b0: 73 74 2d 24 7b 74 65 73 74 73 63 70 5f 74 61 67  st-${testscp_tag
15c0: 7d 22 0a 0a 09 09 09 09 63 6f 6e 74 69 6e 75 65  }"......continue
15d0: 0a 09 09 09 66 69 0a 09 09 64 6f 6e 65 0a 09 64  ....fi...done..d
15e0: 6f 6e 65 0a 64 6f 6e 65 0a 0a 69 66 20 5b 20 2d  one.done..if [ -
15f0: 6e 20 22 24 7b 66 61 69 6c 65 64 7d 22 20 5d 3b  n "${failed}" ];
1600: 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 46 61 69   then..echo "Fai
1610: 6c 65 64 3a 20 24 7b 66 61 69 6c 65 64 7d 22 0a  led: ${failed}".
1620: 66 69 0a                                         fi.